require 'outreach-ruby/model'

module Outreach
  class SequenceState
    extend Outreach::Model

    attr_accessor :id, :sequence_id, :response

    def initialize(attrs)
      @id = attrs['id']
      @sequence_id = attrs['sequence_id']
      @response = attrs['response']
    end

    def self.build_from_attributes_hash(data)
      result = {}
      result['id'] = data['id']
      result['sequence_id'] = nested_hash_value(
        data,
        %w[relationships sequence data id]
      )
      result['response'] = data
      new(result)
    end
  end
end
