require 'outreach-ruby/model'

module Outreach
  class User
    extend Outreach::Model

    attr_accessor :id, :first_name, :last_name, :email, :response

    def initialize(attrs)
      @id = attrs['id']
      @first_name = attrs['first_name']
      @last_name = attrs['last_name']
      @email = attrs['email']
      @response = attrs['response']
    end

    def self.build_from_attributes_hash(data)
      result = {}
      result['id'] = data['id']
      result['first_name'] = nested_hash_value(
        data,
        %w[attributes firstName]
      )
      result['last_name'] = nested_hash_value(
        data,
        %w[attributes lastName]
      )
      result['email'] = nested_hash_value(
        data,
        %w[attributes email]
      )
      result['response'] = data
      new(result)
    end
  end
end
